image: docker:latest
services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay
  SPRING_PROFILES_ACTIVE: gitlab-ci

stages:
  - build
  - package
  - deploy

maven-build:
  image: maven:3-jdk-11
  stage: build
  script: "mvn package -B"
  artifacts:
    paths:
      - target/*.jar

docker-build:
  stage: package
  script:
    - docker build -t registry.gitlab.com/villalabs/pucminas/arquitetura-software-distribuido/saem/lista-presenca:$CI_PIPELINE_ID .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push registry.gitlab.com/villalabs/pucminas/arquitetura-software-distribuido/saem/lista-presenca:$CI_PIPELINE_ID

k8s-deploy:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo "$GOOGLE_KEY" > key.json
    - gcloud auth activate-service-account --key-file key.json
    - gcloud container clusters get-credentials autopilot-cluster-pos --region southamerica-east1 --project prefeitura-municipal-306312
    - kubectl create namespace lista-presenca --dry-run=client -o yaml | kubectl apply -f -
    - sed -i -e "s|IMAGE_TAG|$CI_PIPELINE_ID|g" deployment.yml
    - kubectl apply -f deployment.yml -n lista-presenca
